/* USER CODE BEGIN Header */
/* you can remove the copyright */

/*
 *  Copyright 2020-2023 Yuntu Microelectronics co.,ltd
 *  All rights reserved.
 * 
 *  YUNTU Confidential. This software is owned or controlled by YUNTU and may only be
 *  used strictly in accordance with the applicable license terms. By expressly
 *  accepting such terms or by downloading, installing, activating and/or otherwise
 *  using the software, you are agreeing that you have read, and that you agree to
 *  comply with and are bound by, such license terms. If you do not agree to be
 *  bound by the applicable license terms, then you may not retain, install,
 *  activate or otherwise use the software. The production use license in
 *  Section 2.3 is expressly granted for this software.
 * 
 * @file main.c
 * @brief 
 * 
 */

/* USER CODE END Header */
#include "sdk_project_config.h"
/* Includes ------------------------------------------------------------------*/

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "osif.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
/* USER CODE END PV */

/* Private function declare --------------------------------------------------*/
/* USER CODE BEGIN PFDC */
/* USER CODE END PFDC */
static void Board_Init(void);

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
/* USER CODE END 0 */


/**
 * @brief  The application entry point.
 * @retval int
 */
int main(void)
{
    /* USER CODE BEGIN 1 */
    /* USER CODE END 1 */ 
    Board_Init();
    /* USER CODE BEGIN 2 */
    /* PWM is generated when eTMR enable, the duty cycle is configured in the initial function */
    //eTMR_DRV_Enable(0);
    OSIF_TimeDelay(10);

    /* The following code shows how to switch the different duty cycle */
    /* channel 2 duty cycle is 50% */
    eTMR_DRV_UpdatePwmChannel(0, 0, 0x4000U, 0);
    /* channel 3 duty cycle is 50% */
    eTMR_DRV_UpdatePwmChannel(0, 1, 0x4000U, 0);
    eTMR_DRV_UpdatePwmChannel(0, 4, 0x4000U, 0);
    /* channel 3 duty cycle is 50% */
    eTMR_DRV_UpdatePwmChannel(0, 5, 0x4000U, 0);
    eTMR_DRV_SetLdok(0);
    OSIF_TimeDelay(100);

    /* channel 1 100% duty cycle, here is the workaround for 100% duty cycle */
    eTMR0->CH[1].VAL0 = 0;
    eTMR0->CH[1].VAL1 = eTMR0->MOD + 1;

    /* channel 4 100% duty cycle, here is the workaround for 100% duty cycle */
    eTMR0->CH[4].VAL0 = 0;
    eTMR0->CH[4].VAL1 = eTMR0->MOD + 1;

    /* channel 0 duty cycle is 0 */
    eTMR_DRV_UpdatePwmChannel(0, 0, 0, 0);
    /* channel 5 duty cycle is 0*/
    eTMR_DRV_UpdatePwmChannel(0, 5, 0, 0);
    eTMR_DRV_SetLdok(0);
    OSIF_TimeDelay(10);
    /* USER CODE END 2 */

    /* Infinite loop */
    /* USER CODE BEGIN WHILE */
    while (1)
    {
        /* USER CODE END WHILE */
        /* USER CODE BEGIN 3 */
    }
    /* USER CODE END 3 */
}

static void Board_Init(void)
{
    CLOCK_SYS_Init(g_clockManConfigsArr,CLOCK_MANAGER_CONFIG_CNT,g_clockManCallbacksArr,CLOCK_MANAGER_CALLBACK_CNT);
    CLOCK_SYS_UpdateConfiguration(CLOCK_MANAGER_ACTIVE_INDEX,CLOCK_MANAGER_POLICY_AGREEMENT);
    PINS_DRV_Init(NUM_OF_CONFIGURED_PINS0,g_pin_mux_InitConfigArr0);
    eTMR_DRV_Init(0,&ETMR_CM_Config0,&ETMR_CM_Config0_State);
    eTMR_DRV_InitPwm(0,&ETMR_PWM_Config0);
}

/* USER CODE BEGIN 4 */
/* USER CODE END 4 */
